Robotsystem of the Robot Group Leipzig: lpzrobots Namespace Reference

- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages
- Examples

- Search for |

- Namespace List
- Namespace Members

# lpzrobots Namespace Reference

read the installation PREFIX (to find data directory) More...

## Classes
class | OdeAgent
| Specialised agent for ode robots. More...
class | AngularMotor
| Abstract angular motor class. More...
class | AngularMotor1Axis
| Angular motor for OneAxisJoints. More...
class | AngularMotor2Axis
| Angular motor for TwoAxisJoints. More...
class | AngularMotor3AxisEuler
| Angular motor for Ball Joints with Euler control. More...
class | AngularMotorNAxis
| Angular motor for arbitrary Joints with custom axis (up to 3). More...
class | DummyMotor
class | Motor
| Abstact base class for attachable motors. More...
class | OneAxisServo
| general servo motor More...
class | PID
class | Speaker
class | TwoAxisServo
| general servo motor for 2 axis joints More...
class | AbstractGround
class | AbstractObstacle
| Abstract class (interface) for obstacles. More...
class | ClosedPlayground
class | PolyLine
class | ComplexPlayground
| Playground that uses xfig file with polylines linetype 0 is normal line linetype 1 is border thickness is used as well, thickness is multiplied with wallthickness. More...
class | MeshGround
class | MeshObstacle
class | OctaPlayground
class | PassiveBox
| (Passive) box as obstacle More...
class | PassiveCapsule
| (Passive) capsule as obstacle More...
class | PassiveMesh
| (Passive) mesh as obstacle More...
class | PassiveSphere
| (Passive) sphere as obstacle More...
class | Playground
class | TerrainGround
| Class provides an terrain based on HeightFields. More...
class | OdeConfig
| The class $name holds the configurable parameters of the simulation environment. More...
class | MoveEarthySkyWithEyePointTransform
class | Base
class | BoundingShape
| class for reading bounding shape description files (.bbox) and to create appropriate geoms More...
class | CameraManipulator
| CameraManipulator is a MatrixManipulator which provides Flying simulator-like updating of the camera position & orientation. More...
class | CameraManipulatorFollow
| CameraManipulatorFollow is a MatrixManipulator which provides Flying simulator-like updating of the camera position & orientation. More...
class | CameraManipulatorRace
| CameraManipulatorRace is a MatrixManipulator which provides Flying simulator-like updating of the camera position & orientation. More...
class | CameraManipulatorTV
| CameraManipulatorTV is a MatrixManipulator which provides Flying simulator-like updating of the camera position & orientation. More...
struct | Indices
struct | Vertex
class | HeightField
| Height field primitive. More...
class | HUDStatisticsManager
| manages all the stuff displaying statistics on the graphics window. More...
class | Joint
class | OneAxisJoint
class | TwoAxisJoint
class | FixedJoint
class | HingeJoint
class | Hinge2Joint
class | UniversalJoint
class | BallJoint
class | SliderJoint
class | MotionBlurOperation
| a class that enables motion blur for the scenegraph should be called in the main simulation loop More...
class | MotionBlurDrawCallback
| a class that enables motion blur for the scenegraph should be called in the main simulation loop More...
class | OSGHeightField
| Graphical HeightField. More...
class | OSGPrimitive
| Interface class for graphic primitives like spheres, boxes, and meshes, which can be drawn by OSG. More...
class | OSGDummy
| A dummy graphical object, which has no representation in the graphical world. More...
class | OSGPlane
| Graphical plane (represented as a large thin box, because OSG does not draw planes). More...
class | OSGBox
| Graphical box. More...
class | OSGSphere
| Graphical sphere. More...
class | OSGCapsule
| Graphical capsule (a cylinder with round ends). More...
class | OSGCylinder
| Graphical cylinder. More...
class | OSGMesh
| Graphical Mesh or arbitrary OSG model. More...
class | Primitive
| Interface class for primitives represented in the physical and graphical world. More...
class | Plane
| Plane primitive. More...
class | Box
| Box primitive. More...
class | Sphere
| Sphere primitive. More...
class | Capsule
| Capsule primitive. More...
class | Cylinder
| Cylinder primitive. More...
class | Ray
| Ray primitive The actual visual representation can have different length than the ray object. More...
class | Mesh
| Mesh primitive. More...
class | Transform
| Primitive for transforming a geom (primitive without body) in respect to a body (primitive with body). More...
class | DummyPrimitive
| Dummy Primitive which returns 0 for geom and body. More...
class | Substance
| Physical substance definition, used for collision detection/treatment What we need is mu, slip and kp,kd parameter for the collision Definition of substance parameters:. More...
class | AddSensors2RobotAdapter
| Robot adapter to add sensors and also motors to robots without the need to modify the robot itself. More...
struct | ArmConf
class | Arm
struct | Arm2SegmConf
class | Arm2Segm
struct | repSlider
struct | AtomConf
struct | TableLine
class | AtomComponent
| AtomComponent. More...
class | Barrel2Masses
| A barrel-like robot with 2 internal masses, which can slide on their orthogonal axes. More...
class | Barrel2Masses2nd
| A barrel-like robot with 2 internal masses, which can slide on their orthogonal axes. More...
class | CaterPillar
| This is a class, which models a snake like robot. More...
struct | _ComponentConf
class | Component
| This is the abstract base class of the component system. More...
struct | CaterPillarConf
class | DefaultCaterPillar
| This is a class, which models a snake like robot. More...
struct | WheelieConf
class | DefaultWheelie
| This is a class, which models a snake like robot. More...
class | ForcedSphereConf
class | ForcedSphere
class | Formel1
| Robot that looks like a Nimm 2 Bonbon :-) 4 wheels and a capsule like body. More...
struct | FourWheeledConf
class | FourWheeled
| Robot is based on nimm4 with 4 wheels and a capsule like body. More...
struct | HandConf
class | Hand
| Artificial Hand. More...
class | HurlingSnake
| Hurling snake is a string a beats. More...
struct | MuscledArmConf
class | MuscledArm
struct | Bumper
struct | Nimm2Conf
class | Nimm2
| Robot that looks like a Nimm 2 Bonbon :-) 2 wheels and a cylinder like body. More...
class | Nimm4
| Robot that looks like a Nimm 2 Bonbon :-) 4 wheels and a capsule like body. More...
class | OdeRobot
| Abstract class for ODE robots. More...
class | PlattfussSchlange
| This is a class, which models a snake like robot with flat ends and a big body in the middle. More...
class | PrimitiveComponent
| Component consisting of one Primitive. More...
class | ReplayRobot
class | RobotComponent
| This is a special class of the component system. More...
struct | SchlangeConf
class | Schlange
| This is a class, which models a snake like robot. More...
class | SchlangeForce
| This is a class, which models a snake like robot. More...
class | SchlangeServo
| This is a class, which models a snake like robot. More...
class | SchlangeServo2
| This is a class, which models a snake like robot. More...
class | SchlangeVelocity
| This is a class, which models a snake like robot. More...
class | ShortCircuit
class | SimpleComponent
| A simple component is a special form of component. More...
struct | SliderWheelieConf
class | SliderWheelie
| This is a class, which models an annular robot. More...
struct | SphererobotConf
class | Sphererobot
| This is a class, which models a snake like robot. More...
struct | Sphererobot3MassesConf
| configuration object for the Sphererobot3Masses robot. More...
class | Sphererobot3Masses
| A spherical robot with 3 internal masses, which can slide on their orthogonal axes. More...
class | TruckMesh
| Robot that looks like a Nimm 2 Bonbon :-) 4 wheels and a truck mesh like body. More...
struct | UwoConf
class | Uwo
| UWO: Unknown Walk Object :-), looks like a plate with a lot of legs. More...
struct | VierBeinerConf
class | VierBeiner
| robot that should look like a dog More...
class | Wheelie
| This is a class, which models an annular robot. More...
class | AxisOrientationSensor
| Class for sensing the axis orienation of a primitive (robot). More...
class | IRSensor
| Class for IR sensors. More...
class | RaySensor
| Abstract class for Ray-based sensors. More...
class | RaySensorBank
| Class for a bank (collection) of ray sensors. More...
class | RelativePositionSensor
| Class for relative position sensing. More...
class | Sensor
| Abstract class for sensors that have no specific position at the robots skeleton. More...
class | SoundSensor
| Sound sensor with possible direction and frequency detection and also distance dependence. More...
class | SpeedSensor
| Class for speed sensing of robots. More...
class | Simulation
class | Axis
class | Color
struct | COMMAND
class | IException
struct | GlobalData
| Data structure holding all essential global information. More...
class | VideoStream
struct | geomPairHash
class | OdeHandle
| Data structure for accessing the ODE. More...
class | OsgHandle
| Data structure for accessing the ODE. More...
class | Pos
class | Sound
| Object that represents a sound signal in the simulator. More...
## Typedefs
typedef OneAxisServo | SliderServo
typedef OneAxisServo | HingeServo
typedef OneAxisServo | Hinge2Servo
typedef TwoAxisServo | UniversalServo
typedef int(*) | CollisionCallback (dSurfaceParameters &params, GlobalData &globaldata, void *userdata, dContact *contacts, int numContacts, dGeomID o1, dGeomID o2, const Substance &s1, const Substance &s2)
| function to be called at a collision event between the two geoms.
typedef lpzrobots::_ComponentConf | ComponentConf
typedef lpzrobots::Bumper | Bumper
typedef bool(*) | commandfunc_t (GlobalData &globalData, char *, char *)
typedef std::vector< AbstractObstacle * > | ObstacleList
typedef std::vector< Configurable * > | ConfigList
typedef std::vector< OdeAgent * > | OdeAgentList
typedef std::list< Sound > | SoundList
## Enumerations
enum | parts { base, base, shoulder1, shoulder2, upperArm, upperArm, foreArm, hand, hand }
enum | Motor_type { With_servo_motor, Without_servo_motor }
enum | IrSensor_Type { irDrawAll, irBack, irSide, irFront }
enum | GripMode { lateral, precision }
enum | parts { base, base, upperArm, upperArm, lowerArm, mainMuscle11, mainMuscle12, mainMuscle21, mainMuscle22, smallMuscle11, smallMuscle12, smallMuscle21, smallMuscle22, smallMuscle31, smallMuscle32, smallMuscle41, smallMuscle42, hand, hand, NUMParts }
enum | joints { HJ_BuA, HJ_uAlA, HJ_BmM11, HJ_lAmM12, HJ_BmM21, HJ_lAmM22, HJ_BsM11, HJ_uAsM12, HJ_BsM21, HJ_uAsM22, HJ_lAsM31, HJ_uAsM32, HJ_lAsM41, HJ_uAsM42, SJ_mM1, SJ_mM2, SJ_sM1, SJ_sM2, SJ_sM3, SJ_sM4, FJ_lAH, NUMJoints }
## Functions
void | printCornerPointsXY (Box *box, FILE *f)
ref_ptr< Material > | getMaterial (const Color &c, Material::ColorMode mode=Material::DIFFUSE)
osg::Matrix | osgPose (dGeomID geom)
| returns the osg (4x4) pose matrix of the ode geom
osg::Matrix | osgPose (dBodyID body)
| returns the osg (4x4) pose matrix of the ode body
osg::Matrix | osgPose (const double *position, const double *rotation)
| converts a position vector and a rotation matrix from ode to osg 4x4 matrix
void | odeRotation (const osg::Matrix &pose, dMatrix3 &odematrix)
| converts the rotation component of pose into an ode rotation matrix
int | dummyCallBack (dSurfaceParameters &params, GlobalData &globaldata, void *userdata, dContact *contacts, int numContacts, dGeomID o1, dGeomID o2, const Substance &s1, const Substance &s2)
int | irCollCallback (dSurfaceParameters &params, GlobalData &globaldata, void *userdata, dContact *contacts, int numContacts, dGeomID o1, dGeomID o2, const Substance &s1, const Substance &s2)
static void * | odeStep_run (void *p)
| redirection function, because we can't call member function direct
static void * | osgStep_run (void *p)
| redirection function, because we can't call member function direct
static void | printODEMessage (int num, const char *msg, va_list ap)
void | createNewDir (const char *base, char *newdir)
| creates a new directory with the stem base, which is not yet there (using subsequent numbers)
void | showParams (const ConfigList &configs)
| shows all parameters of all given configurable objects
bool | com_list (GlobalData &globalData, char *, char *)
bool | com_show (GlobalData &globalData, char *, char *)
bool | com_store (GlobalData &globalData, char *, char *)
bool | com_load (GlobalData &globalData, char *, char *)
bool | com_set (GlobalData &globalData, char *, char *)
bool | com_help (GlobalData &globalData, char *, char *)
bool | com_quit (GlobalData &globalData, char *, char *)
char * | stripwhite (char *string)
COMMAND * | find_command (char *name)
bool | execute_line (GlobalData &globalData, char *line)
int | valid_argument (const char *caller, const char *arg)
void | showParam (const Configurable *config)
char * | dupstr (const char *s)
bool | handleConsole (GlobalData &globalData)
| offers a console interface the possibility to change parameter of all configurable objects in globalData storeing and restoreing of controllers .
char * | command_generator (const char *, int)
char ** | console_completion (const char *, int, int)
void | initializeConsole ()
| should be called at the start
void | closeConsole ()
| should be called at the end (to store history)
| EXCEPTION_TEMPLATE (IndexOutOfBoundsException)
| EXCEPTION_TEMPLATE (InvalidArgumentException)
| EXCEPTION_TEMPLATE (DimensionMismatchException)
osg::Matrix | osgRotate (const double &alpha, const double &beta, const double &gamma)
| returns a rotation matrix (osg) with the given angles alpha, beta and gamma
Matrix | osgMatrix2Matrixlib (const osg::Matrix &m)
| converts osg matrix to matrix of matrixlib
osg::Matrix | rotationMatrixFromAxisX (const Axis &axis)
| returns a Rotation matrix that rotates the x-axis along with the given axis.
osg::Matrix | rotationMatrixFromAxisZ (const Axis &axis)
| returns a Rotation matrix that rotates the z-axis along with the given axis.
double | getAngle (const osg::Vec3 &a, const osg::Vec3 &b)
| returns the angle between two vectors (in rad)
matrix::Matrix | odeRto3x3RotationMatrixT (const double R[12])
| converts an ode rotation matrix into a 3x3 rotation matrix (matrixlib)
matrix::Matrix | odeRto3x3RotationMatrix (const double R[12])
| converts an ode rotation matrix into a 3x3 rotation matrix (matrixlib)
Position | multMatrixPosition (const matrix::Matrix &r, Position &p)
| Multiplies 3x3 matrix with position.
Matrix | getRotationMatrix (const double &angle)
| returns a rotation matrix with the given angle
Matrix | getTranslationMatrix (const Position &p)
| returns a translation matrix with the given Position
Matrix | removeTranslationInMatrix (const matrix::Matrix &pose)
| removes the translation in the matrix
Matrix | removeRotationInMatrix (const matrix::Matrix &pose)
| removes the rotation in the matrix
double | getAngle (Position a, Position b)
| returns the angle between two vectors
template<typename T>
T | normalize360 (T v)
## Variables
char | fragmentShaderSource_noBaseTexture []
char | fragmentShaderSource_withBaseTexture []
static FILE * | ODEMessageFile = 0
COMMAND | commands []

## Detailed Description

read the installation PREFIX (to find data directory)

## Typedef Documentation

typedef OneAxisServo SliderServo

Examples:
  sphererobot3masses.cpp.

typedef OneAxisServo HingeServo

typedef OneAxisServo Hinge2Servo

typedef TwoAxisServo UniversalServo

typedef int(*) CollisionCallback(dSurfaceParameters &params, GlobalData &globaldata, void *userdata, dContact *contacts, int numContacts, dGeomID o1, dGeomID o2, const Substance &s1, const Substance &s2)

function to be called at a collision event between the two geoms.

Parameters:

  | params | surface parameter, which should be changed/calculated by this function
  | globaldata | global information
  | userdata | pointer to user data for this callback (stored in substance)
  | contacts | array of contact information
  | numContacts | length of contact information array
  | o1 | geom corresponding to substance of this callback
  | o2 | other geom
  | s1 | substance of this callback
  | s2 | other substance

Returns:
  0 if collision should not be treated; 1 if collision should be treated otherwise (by other callback or standard methods); 2 if collision to be treated and parameters for collision are set in params

typedef struct lpzrobots::_ComponentConf ComponentConf

typedef struct lpzrobots::Bumper Bumper

typedef bool(*) commandfunc_t(GlobalData &globalData, char *, char *)

typedef std::vector<AbstractObstacle*> ObstacleList

typedef std::vector<Configurable*> ConfigList

typedef std::vector<OdeAgent*> OdeAgentList

typedef std::list<Sound> SoundList

## Enumeration Type Documentation

enum parts

Enumerator:

  base |
  base |
  shoulder1 |
  shoulder2 |
  upperArm |
  upperArm |
  foreArm |
  hand |
  hand |

enum Motor_type

Enumerator:

  With_servo_motor |
  Without_servo_motor |

enum IrSensor_Type

Enumerator:

  irDrawAll |
  irBack |
  irSide |
  irFront |

enum GripMode

Enumerator:

  lateral |
  precision |

enum parts

Enumerator:

  base |
  base |
  upperArm |
  upperArm |
  lowerArm |
  mainMuscle11 |
  mainMuscle12 |
  mainMuscle21 |
  mainMuscle22 |
  smallMuscle11 |
  smallMuscle12 |
  smallMuscle21 |
  smallMuscle22 |
  smallMuscle31 |
  smallMuscle32 |
  smallMuscle41 |
  smallMuscle42 |
  hand |
  hand |
  NUMParts |

enum joints

Enumerator:

  HJ_BuA |
  HJ_uAlA |
  HJ_BmM11 |
  HJ_lAmM12 |
  HJ_BmM21 |
  HJ_lAmM22 |
  HJ_BsM11 |
  HJ_uAsM12 |
  HJ_BsM21 |
  HJ_uAsM22 |
  HJ_lAsM31 |
  HJ_uAsM32 |
  HJ_lAsM41 |
  HJ_uAsM42 |
  SJ_mM1 |
  SJ_mM2 |
  SJ_sM1 |
  SJ_sM2 |
  SJ_sM3 |
  SJ_sM4 |
  FJ_lAH |
  NUMJoints |

## Function Documentation

void lpzrobots::printCornerPointsXY | ( | Box * | box,
|  | FILE * | f |
| ) |  |  |

ref_ptr< Material > getMaterial | ( | const Color & | c,
|  | Material::ColorMode | mode = `Material::DIFFUSE` |
| ) |  |  |

osg::Matrix osgPose | ( | dGeomID | geom | ) |

returns the osg (4x4) pose matrix of the ode geom

osg::Matrix osgPose | ( | dBodyID | body | ) |

returns the osg (4x4) pose matrix of the ode body

osg::Matrix osgPose | ( | const double * | V,
|  | const double * | R |
| ) |  |  |

converts a position vector and a rotation matrix from ode to osg 4x4 matrix

void odeRotation | ( | const osg::Matrix & | pose,
|  | dMatrix3 & | odematrix |
| ) |  |  |

converts the rotation component of pose into an ode rotation matrix

int lpzrobots::dummyCallBack | ( | dSurfaceParameters & | params,
|  | GlobalData & | globaldata,
|  | void * | userdata,
|  | dContact * | contacts,
|  | int | numContacts,
|  | dGeomID | o1,
|  | dGeomID | o2,
|  | const Substance & | s1,
|  | const Substance & | s2 |
| ) |  |  |

int lpzrobots::irCollCallback | ( | dSurfaceParameters & | params,
|  | GlobalData & | globaldata,
|  | void * | userdata,
|  | dContact * | contacts,
|  | int | numContacts,
|  | dGeomID | o1,
|  | dGeomID | o2,
|  | const Substance & | s1,
|  | const Substance & | s2 |
| ) |  |  |

static void * odeStep_run | ( | void * | p | ) | `[static]`

redirection function, because we can't call member function direct

static void * osgStep_run | ( | void * | p | ) | `[static]`

redirection function, because we can't call member function direct

static void printODEMessage | ( | int | num,
|  | const char * | msg,
|  | va_list | ap |
| ) |  |  | `[static]`

void createNewDir | ( | const char * | base,
|  | char * | newdir |
| ) |  |  |

creates a new directory with the stem base, which is not yet there (using subsequent numbers)

void showParams | ( | const ConfigList & | configs | ) |

shows all parameters of all given configurable objects

bool com_list | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_show | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_store | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_load | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_set | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_help | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

bool com_quit | ( | GlobalData & | globalData,
|  | char * | ,
|  | char * |  |
| ) |  |  |

char * stripwhite | ( | char * | string | ) |

COMMAND * find_command | ( | char * | name | ) |

bool execute_line | ( | GlobalData & | globalData,
|  | char * | line |
| ) |  |  |

int valid_argument | ( | const char * | caller,
|  | const char * | arg |
| ) |  |  |

void lpzrobots::showParam | ( | const Configurable * | config | ) |

char* lpzrobots::dupstr | ( | const char * | s | ) |

bool handleConsole | ( | GlobalData & | globalData | ) |

offers a console interface the possibility to change parameter of all configurable objects in globalData storeing and restoreing of controllers .

.. also informs agents about changes

Returns:
  false if program should exit

char * command_generator | ( | const char * | ,
|  | int |  |
| ) |  |  |

char ** console_completion | ( | const char * | ,
|  | int | ,
|  | int |  |
| ) |  |  |

void initializeConsole | ( |  | ) |

should be called at the start

void closeConsole | ( |  | ) |

should be called at the end (to store history)

lpzrobots::EXCEPTION_TEMPLATE | ( | IndexOutOfBoundsException |  | ) |

lpzrobots::EXCEPTION_TEMPLATE | ( | InvalidArgumentException |  | ) |

lpzrobots::EXCEPTION_TEMPLATE | ( | DimensionMismatchException |  | ) |

osg::Matrix osgRotate | ( | const double & | alpha,
|  | const double & | beta,
|  | const double & | gamma |
| ) |  |  |

returns a rotation matrix (osg) with the given angles alpha, beta and gamma

matrix::Matrix osgMatrix2Matrixlib | ( | const osg::Matrix & | m | ) |

converts osg matrix to matrix of matrixlib

osg::Matrix rotationMatrixFromAxisX | ( | const Axis & | axis | ) |

returns a Rotation matrix that rotates the x-axis along with the given axis.

The other 2 axis (y,z) are ambiguous.

osg::Matrix rotationMatrixFromAxisZ | ( | const Axis & | axis | ) |

returns a Rotation matrix that rotates the z-axis along with the given axis.

The other 2 axis (x,y) are ambiguous.

double getAngle | ( | const osg::Vec3 & | a,
|  | const osg::Vec3 & | b |
| ) |  |  |

returns the angle between two vectors (in rad)

matrix::Matrix odeRto3x3RotationMatrixT | ( | const double | R[12] | ) |

converts an ode rotation matrix into a 3x3 rotation matrix (matrixlib)

matrix::Matrix odeRto3x3RotationMatrix | ( | const double | R[12] | ) |

converts an ode rotation matrix into a 3x3 rotation matrix (matrixlib)

Position multMatrixPosition | ( | const Matrix & | r,
|  | Position & | p |
| ) |  |  |

Multiplies 3x3 matrix with position.

matrix::Matrix getRotationMatrix | ( | const double & | angle | ) |

returns a rotation matrix with the given angle

matrix::Matrix getTranslationMatrix | ( | const Position & | p | ) |

returns a translation matrix with the given Position

matrix::Matrix removeTranslationInMatrix | ( | const Matrix & | pose | ) |

removes the translation in the matrix

matrix::Matrix removeRotationInMatrix | ( | const Matrix & | pose | ) |

removes the rotation in the matrix

double getAngle | ( | Position | a,
|  | Position | b |
| ) |  |  |

returns the angle between two vectors

T lpzrobots::normalize360 | ( | T | v | ) | `[inline]`

## Variable Documentation

char fragmentShaderSource_noBaseTexture[]

Initial value:

      "uniform sampler2DShadow shadowTexture; \n"
      "uniform vec2 ambientBias; \n"
      "\n"
      "void main(void) \n"
      "{ \n"
      "    ambientBias.x=0.8f; \n"
      "    ambientBias.y=0.4f; \n"
      "    gl_FragColor = gl_Color * (ambientBias.x + shadow2DProj( shadowTexture, gl_TexCoord[0] ) * ambientBias.y - 0.4f); \n"
      "}\n"

char fragmentShaderSource_withBaseTexture[]

Initial value:

      "uniform sampler2D baseTexture; \n"
      "uniform sampler2DShadow shadowTexture; \n"
      "uniform vec2 ambientBias; \n"
      "\n"
      "void main(void) \n"
      "{ \n"
      "    vec4 color = gl_Color* texture2D( baseTexture, gl_TexCoord[0].xy ); \n"
      "    gl_FragColor = color * (ambientBias.x + shadow2DProj( shadowTexture, gl_TexCoord[1])  * ambientBias.y); \n"
      "}\n"

FILE* ODEMessageFile = 0`[static]`

COMMAND commands[]

Initial value:

     {
      { "param=val",  com_set, "sets PARAM of all objects to VAL" },
      { "help", com_help, "Display this text" },
      { "?",     com_help, "Synonym for `help'" },
      { "list", com_list, "Lists all objects and agents" },
      { "ls",   com_list, "Synonym for `list'" },
      { "set",  com_set, "syntax: set [OBJECTID] PARAM=VAL; sets parameter of Object (or all all objects) to value" },
      { "store", com_store, "Stores controller of AGENTID to FILE" },
      { "load", com_load, "Loads controller of AGENTID from FILE" },
      { "show", com_show, "[OBJECTID]: Lists paramters of OBJECTID or of all objects (if no id given)" },
      { "view", com_show, "Synonym for `show'" },
      { "quit", com_quit, "Quit program" },
      { (char *)NULL, (commandfunc_t)NULL, (char *)NULL }
    }